/**
 Trivial pthreads program, now FIXED: count is now private,
  with a separate copy used by each thread.
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

/* Describes a range of numbers to count */
struct number_range {
	int lo, hi;
	int count;
};

void count_range(number_range *n) {
	for (int i=n->lo;i<n->hi;i++) 
		if ((i%2)==0) 
		{ /* i is even-- add it to the count */
			n->count++;
		}
}

void *count_thread(void *ptr) {
	number_range *n=(number_range *)ptr;
	count_range(n);
}

int main() {
	number_range An;
	number_range Bn;
	An.lo=0;
	An.hi=Bn.lo=50000000;
	Bn.hi=100000000;
	An.count=Bn.count=0;
	
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_t A;
	pthread_create(&A,&attr,count_thread,&An);
	count_range(&Bn);
	pthread_join(A,0);
	
	printf("Total count: %d\n",An.count+Bn.count);
	return 0;
}
